// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOpenGLFunctions_3_3_CoreWrapper_H
#define SBK_QOpenGLFunctions_3_3_CoreWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_3_3_core.h>

class QOpenGLFunctions_3_3_CoreWrapper : public QOpenGLFunctions_3_3_Core
{
public:
    QOpenGLFunctions_3_3_CoreWrapper(const QOpenGLFunctions_3_3_CoreWrapper &) = delete;
    QOpenGLFunctions_3_3_CoreWrapper& operator=(const QOpenGLFunctions_3_3_CoreWrapper &) = delete;
    QOpenGLFunctions_3_3_CoreWrapper(QOpenGLFunctions_3_3_CoreWrapper &&) = delete;
    QOpenGLFunctions_3_3_CoreWrapper& operator=(QOpenGLFunctions_3_3_CoreWrapper &&) = delete;

    QOpenGLFunctions_3_3_CoreWrapper();
    bool initializeOpenGLFunctions() override;
    ~QOpenGLFunctions_3_3_CoreWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOpenGLFunctions_3_3_CoreWrapper_H

