// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlaceProposedSearchResultWrapper_H
#define SBK_QPlaceProposedSearchResultWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplaceproposedsearchresult.h>

class QPlaceProposedSearchResultWrapper : public QPlaceProposedSearchResult
{
public:
    QPlaceProposedSearchResultWrapper(const QPlaceProposedSearchResultWrapper &) = delete;
    QPlaceProposedSearchResultWrapper& operator=(const QPlaceProposedSearchResultWrapper &) = delete;
    QPlaceProposedSearchResultWrapper(QPlaceProposedSearchResultWrapper &&) = delete;
    QPlaceProposedSearchResultWrapper& operator=(QPlaceProposedSearchResultWrapper &&) = delete;

    QPlaceProposedSearchResultWrapper();
    QPlaceProposedSearchResultWrapper(const ::QPlaceSearchResult & other);
    ~QPlaceProposedSearchResultWrapper() override;
    static void pysideInitQtMetaTypes();
private:
};

#endif // SBK_QPlaceProposedSearchResultWrapper_H

