// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOpenGLFunctions_3_0Wrapper_H
#define SBK_QOpenGLFunctions_3_0Wrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_3_0.h>

class QOpenGLFunctions_3_0Wrapper : public QOpenGLFunctions_3_0
{
public:
    QOpenGLFunctions_3_0Wrapper(const QOpenGLFunctions_3_0Wrapper &) = delete;
    QOpenGLFunctions_3_0Wrapper& operator=(const QOpenGLFunctions_3_0Wrapper &) = delete;
    QOpenGLFunctions_3_0Wrapper(QOpenGLFunctions_3_0Wrapper &&) = delete;
    QOpenGLFunctions_3_0Wrapper& operator=(QOpenGLFunctions_3_0Wrapper &&) = delete;

    QOpenGLFunctions_3_0Wrapper();
    bool initializeOpenGLFunctions() override;
    ~QOpenGLFunctions_3_0Wrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOpenGLFunctions_3_0Wrapper_H

